#!/bin/sh

# This file is free software; the Free Software Foundation    
# gives unlimited permission to copy, distribute and modify it.

echo for all .c/.h/.cpp/.m4 source files:

if test -x `dirname $0`/../bin/dune; then
   `dirname $0`/../bin/dune --copyrightdetails
else
   dune --copyrightdetails
   if test "$?" != "0"; then
      echo run \"dune --copyrightdetails\" for copyright details
   fi
fi

TMPFILE=${TMPDIR}/tmp/findcopyrights_$$.tmp

find `dirname $0`/.. -type f -print > $TMPFILE

awk -v dir=`dirname $0`/.. '
   function chompdir(str) {
      sub(dir "/", "", str)
      return str
   }
   { flag=0 }
   $1~/Dampers.wrl$/ { flag=1; print "\nLicense of lib/VRML97protos/Dampers.wrl:\n\nYou can use, copy and modify the PROTO in this file if you keep the\ncredit information valid and if you dont remove the link to the\noriginating site http://www.hersto.de/" }
   # matched by --copyright
   $1~/\.c$/ { flag=1 }
   $1~/\.h$/ { flag=1 }
   $1~/\.cpp$/ { flag=1 }
   $1~/\.o$/ { flag=1 }
   $1~/\.a$/ { flag=1 }
   # copyright in /lib/textures/
   $1~/lib\/textures/ { flag=1; libtextures = libtextures "\n" $1 }
   $1~/\.jpg$/ || $1~/\.png$/ { flag=1
                 if (system("identify -verbose " $1 " | grep \"the Free Software Foundation gives unlimited\" > /dev/null")==0)
                    simple[simpleLen++] = $1
               }

   { 
      if (flag == 0) { 
         # simple permissive copyright
         if (system("grep \"unlimited permission to copy, distribute and modify it\" " $1 " > /dev/null")==0)
            simple[simpleLen++] = chompdir($1);
         else if (system("grep \"under the terms of the GNU General Public\" " $1 " > /dev/null")==0)
            gnu[gnuLen++] = chompdir($1);
         else if (system("grep \"under the terms of the GNU Library General Public\" " $1 " > /dev/null")==0)
            lgnu[lgnuLen++] = chompdir($1);
         else
            rest[restLen++] = chompdir($1)
      }
   }

END { 
   print ""
   print "The following statement is about the files in /lib/textures/README"
   system(" cat " dir "/lib/textures/README")
   print ""
   print "The following files use the GNU General Public License:"
   if (ARGV[1] == "debian")
      print "See /usr/share/common-licenses/GPL for the full license"
   print ""
   for (i = 0; i < gnuLen; i++)
        print gnu[i]
   print ""
   print "The following files use the GNU Library General Public License:"
   if (ARGV[1] == "debian")
      print "See /usr/share/common-licenses/LGPL for the full license"
   print ""
   for (i = 0; i < lgnuLen; i++)
        print lgnu[i]
   print ""
   print "The following files use a copyright similar to:"
   print ""
   print "This file/thing is free software; the Free Software Foundation"
   print "gives unlimited permission to copy, distribute and modify it."
   print ""
   for (i = 0; i < simpleLen; i++)
        print simple[i]
   print ""
   for (i = 0; i < restLen; i++)
        print rest[i]
}' $TMPFILE

rm $TMPFILE
